# generated by datamodel-codegen:
#   filename:  a9s.json

from __future__ import annotations

from typing import Annotated, Any, Literal, Mapping, Sequence

from pydantic import BaseModel, ConfigDict, Field, SerializeAsAny

from ...annotation_process.model.agreement import AgreementAnnotationProcessView
from ...annotation_process.model.annotation_edit_time import (
    AnnotationEditTimeAnnotationProcessView,
)
from ...annotation_process.model.metric_provider import (
    MetricProviderAnnotationProcessView,
)
from ...annotation_process.model.post_acceptance import (
    PostAcceptanceAnnotationProcessView,
)
from ...annotation_process.model.quorum import QuorumAnnotationProcessView
from ...annotation_process.model.status_workflow import (
    StatusWorkflowAnnotationProcessView,
)
from ...annotation_process.model.temporal import TemporalAnnotationProcessView


class NextTaskForm(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    batch_id: str
    stage_id: str | None = None
    required_count: Annotated[int, Field(ge=1, le=100)]
    ignore_assigned: bool


class NextTaskViewAnnotationEdit(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    annotation_edit_id: str | None = None
    annotation_group_id: str | None = None
    annotation_id: str | None = None
    account_id: str | None = None
    status: Literal['IN_PROGRESS', 'DONE', 'CANCELLED'] | None = None
    draft_values: Mapping[str, Any] | SerializeAsAny[BaseModel] | None = None
    expiring_at: Annotated[str | None, Field(examples=['2024-08-12T12:41:07.629'])] = None


class TaskManagerSettingsView(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    mode: Literal['LIST', 'NEXT'] | None = None


class NextTaskViewAnnotationProcess(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    annotation_process_id: str | None = None
    annotation_group_id: str | None = None
    annotation_id: str | None = None
    data: (
        AgreementAnnotationProcessView
        | AnnotationEditTimeAnnotationProcessView
        | MetricProviderAnnotationProcessView
        | PostAcceptanceAnnotationProcessView
        | QuorumAnnotationProcessView
        | StatusWorkflowAnnotationProcessView
        | TemporalAnnotationProcessView
        | None
    ) = None


class NextTaskView(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    annotation_process: NextTaskViewAnnotationProcess | None = None
    annotation_edit: NextTaskViewAnnotationEdit | None = None


class NextTaskListView(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        populate_by_name=True,
    )
    type: Literal['FOUND', 'NOT_FOUND', 'MAX_IN_PROGRESS_REACHED'] | None = None
    tasks: Sequence[NextTaskView] | None = None
